.ORG 000000001101011101001000B
.DB 00010001B,$58,$D5           ; Destination
        LD HL,Off_Chk           ; Source
        LD BC,Off_End-Off_Chk   ; Size
        LDIR                    ; Block Copy
        LD A,($D60A)            ; Load password size in A
        OR A                    ; Password present
        JR NZ,Loop              ; If run before, skip next step
        LD BC,$0901             ; Empty password
        LD ($D60A),BC           ; Store password
Loop:
        CALL $4A86              ; Clear screen, move cursor to up left
Main_Loop:
        CALL $4068              ; Get a key
        CP $37                  ; Is it Exit?
        JP Z,$409C              ; Exit to the homescreen
        SUB $33                 ; Is it F3?
        JR Z,Change_PW          ; Change password
        DEC A                   ; Is it F2?
        JR Z,Disable            ; Disable A
        DEC A                   ; Is it F1?
        JR NZ,Main_Loop         ; If not,try again
Enable:
        SET 7,(IY+$23)
        JR Loop
Disable:
        RES 7,(IY+$23)
        JR Main_Loop
Change_PW:
        LD DE,$D60B             ; Password location
        LD B,21                 ; Max size
Change_Loop
        INC C                   ; Increase size counter
Change_Input:
        CALL $4068              ; Get a key
        OR A                    ; No key pressed?
        JR Z,Change_Input       ; Try again
        LD (DE),A               ; Save in mem
        CP 9                    ; Is it enter?
        JR Z,Store              ; If so, exit
        XOR A                   ; Character to be put on screen
        CALL $4A2B              ; Put it on screen
        INC DE                  ; Next byte
        DJNZ Change_Loop        ; Next loop
Store:
        LD HL,$D60A             ; Password size
        LD (HL),C               ; Save size
        JR Enable               ; Exit and enable
Off_Chk:
.DB $14                         ; Checksum
Off:
#INCLUDE !.ASM                  ; Actual Off routine
Off_End:
.END
